// QC CONNECTOR --> WORKS ONLY WITH IE !!!!!
var td;
var log = log4javascript.getDefaultLogger();

//backward compatibility to IE8 which does not support html / video tag
document.createElement('video');


function qc_init()
{
	try
	{
		td = new ActiveXObject("TDApiOle80.TDConnection");
		
	}
	catch (e) 
	{
		alert("You need to install QC locally.");
		// delete some div containers
		var qcexporter = document.getElementById("qc_export")
		
		qcexporter.parentNode.removeChild(qcexporter);		
	}
}
function detectbrowser()
{
	var isIE = /*@cc_on!@*/false || !!document.documentMode;   // At least IE6
	if(!isIE)
	{
		// delete some div containers
		var qcexporter = document.getElementById("qc_export")
		qcexporter.parentNode.removeChild(qcexporter);
	}
	else
	{
		qc_init();
		
	}
}
//function for button connecting AND disconnecting to QC
function qc_connect()
{
	if(td)
	{	
		try
		{
			//checks if already connected
			if (td.Connected == false)
			{
				//updates status div
				document.getElementById("connection_status").innerHTML='Verbindungsaufbau....';
				//establishs connection to qc with user name and pw
				td.InitConnectionEx("https://alm.bmwgroup.net/qcbin");
				
				//username and pw for ALM
				td.Login(document.getElementById("username").value,document.getElementById("password").value);
				
				//domain and project name for ALM
				td.Connect(document.getElementById("domain").value,document.getElementById("project").value);
				
				//if the connection is established div container text is updated
				if (td.Connected == true)
				{
					//change connection_status div
					document.getElementById("connection_status").innerHTML='connected';
					//rename button text
					document.getElementById("button_connect").innerHTML='Disconnect';
					document.getElementById("connection_status").style.backgroundColor = "#19BF19";
					document.getElementById("qc_fields").style.visibility = 'visible';
					
					//sort ECU Dropdown list
					sortdropdown(bg_project);
				}
			}
			//else --> disconnects QC
			else
			{
				//disconnect from QC
				td.Disconnect();
				td.Logout();
				td.ReleaseConnection();
				
				//updating status fields
				document.getElementById("connection_status").innerHTML='disconnected';
				document.getElementById("button_connect").innerHTML='Connect';
				document.getElementById("connection_status").style.backgroundColor = "#FF6600";
				
				//hidding project selection
				document.getElementById("qc_fields").style.visibility = 'hidden';
				
			}
		}
		catch (error)
		{
			td.Disconnect();
			td.Logout();
			td.ReleaseConnection();
			document.getElementById("connection_status").innerHTML='disconnected';
			document.getElementById("connection_status").style.backgroundColor = "#19BF19";
			alert("Fehler beim Verbindungsaufbau: " + error);
			
		}
	}
}
function testing()
{

}

function qc_export()
{	
	//display waiting sand timer
	document.getElementById("connection_status").innerHTML = "<img src=\"data/waiting.gif\">";
	
	if(td.Connected == true)
	{	
		//throws popup asking for export to QC
		if (confirm("Export marked errors to QC?")==true)
		{
			try
			{	
				//get bugfactory, table object and nr of table rows
				var bugfactory = td.BugFactory;
				var err_table = document.getElementById("tablebody_newtickets");
				var nr_rows = err_table.childNodes.length;
				var ticket_count = 0;
				
				//iterate through table, check for checkbox and export ticket
				for (var i=0; i<nr_rows; i++)
				{	
					if (err_table.childNodes[i].nodeName == "TR")	{
					if (err_table.childNodes[i].getElementsByTagName('input')[0].checked==true)
					{
						ticket_count++;
						var err_descr = "Test driver: " + document.getElementById("tester_name").innerHTML + "\n ";
                        err_descr += "Error time: " + err_table.childNodes[i].getElementsByTagName('TD')[4].innerText + "\n ";
                        err_descr += "Location: " + err_table.childNodes[i].getElementsByTagName('TD')[6].innerText + "\n ";
                        err_descr += "HU SW Version: " + document.getElementById("sw").innerHTML + "\n ";
                        err_descr += "Navigation DB Version: " + document.getElementById("db").innerHTML + "\n ";
                        err_descr += "Error description: " + err_table.childNodes[i].getElementsByTagName('TD')[5].innerText  + "\n ";
						//log.info(err_descr);
						err_descr += "This ticket was created automatically by "+ document.getElementById("username").value + ". All missing ticket information will be added in the near future.\n Copyright MAGNA Telemotive GmbH 2015";
						
						var bg_project_value = document.getElementById("bg_project").value;
						var bg_user_55_value = document.getElementById("bg_user_55").value;
						var bg_user_17_value = document.getElementById("bg_user_17").value;					
												
						var bug = bugfactory.AddItem(null);
						bug.Field("BG_STATUS") =  "00-Draft"; // bmw status
						bug.Field("BG_USER_55") = bg_user_55_value; // lead model
						bug.Field("BG_USER_35") = bg_user_55_value; // model involved
						bug.Field("BG_USER_06") = "F020-14-11-431"; //i-step
						bug.Field("BG_USER_20") = "EI"; // Transfer to
						bug.Field("BG_USER_19") = "03-System"; // visible for
						bug.Field("BG_SEVERITY") = "05-unsatisfactory"; // problem severity
						bug.Field("BG_USER_12") =  document.getElementById("username").value; // problem finder
						bug.Field("BG_USER_17") =  bg_user_17_value; // analysis team
						bug.Field("BG_DESCRIPTION") = err_descr; // problem description
						bug.Field("BG_PROJECT") =  bg_project_value; // assigned ecu
						bug.Field("BG_SUMMARY") =  "[Draft] Ticket created by Telemotive Easy Track App, MAGNA Telemotive GmbH 2015 "; // ticket title
						bug.Field("BG_USER_07") = "xxxxxxx"; //ecu sw
						bug.Field("BG_USER_16") = "04-reproducable"; //error occurance
						bug.Field("BG_USER_54") = "EI"; //origin
						bug.Field("BG_RESPONSIBLE") = document.getElementById("username").value; //bmw responsible --> user
						bug.Field("BG_USER_30") = "problem"; // problem type
						bug.Field("BG_USER_39") = "01-CoC"; // Detected on
						bug.Field("BG_USER_65") = "N"; // archivied
						bug.Post();
						// Adding attachments to a ticket
						//---------------------------------------------------
						//adding attachments to the ticket
						var path;
						var img_count = err_table.childNodes[i].getElementsByTagName('TD')[1].getElementsByTagName("a").length;
                        var vid_count = err_table.childNodes[i].getElementsByTagName('TD')[2].getElementsByTagName("video").length;
                        var aud_count = err_table.childNodes[i].getElementsByTagName('TD')[3].getElementsByTagName("a").length;
                 							
						//determine how many images are in the ticket
						if(img_count > 0)
						{
												
						//attaching all images to the ticket
							for (var j=0; j<=img_count-1; j++)
							{
								//getting path and attaching file to ticket
								path = err_table.childNodes[i].getElementsByTagName('TD')[1].getElementsByTagName("a")[j].pathname;
								//log.info("Bild Anhang: " + path);
								attach_file(path, bug);
							}
						}
						
						if(vid_count > 0)
						{												
						//attaching all videos to the ticket
							for (var j=0; j<=vid_count-1; j++)
							{
								//getting path and attaching file to ticket
								path = err_table.childNodes[i].getElementsByTagName('TD')[2].getElementsByTagName("a")[j].href;
								path = path.substring(7,path.length);
								//log.info("Video Anhang: " + path);
								attach_file(path, bug);
							}
						}
						
						if(aud_count > 0)
						{												
						//attaching all audios to the ticket
							for (var j=0; j<=aud_count-1; j++)
							{
								//attaching all videos to the ticket  
								path = err_table.childNodes[i].getElementsByTagName('TD')[3].getElementsByTagName("a")[j].href;
								path = path.substring(7,path.length);
								//log.info("Audio Anhang: " + path);
								attach_file(path, bug);
							}
						}
						
					}
					}
				}
			
			//setting status information
			document.getElementById("connection_status").innerHTML = "Finished Export";
			document.getElementById("connection_status").style.backgroundColor = "#19BF19";
			
			}
			catch (error)
			{
				log.fatal(error);
			}
		}
		//if cancel is pressed --> do nothing
		else
		{
		}
	
	}
	else	{ 
		alert("You are not connected to QC !");
		//setting status information
		document.getElementById("connection_status").innerHTML = "Not connected to QC!";
		document.getElementById("connection_status").style.backgroundColor = "#FF6600";
	}
	
	alert("Es wurden "+ticket_count+" neue Tickets erfolgreich in Quality Center erstellt.");
	}
function attach_file(path, bug)
{
	//this function needs the full path to the file including the file name and file typ + the QC bug object; Hint: Depending on usage of IE8 or IE11 the first character of the path is removed
	
	//separating file name and path to file
	var slash = path.lastIndexOf("/");
	var name = path.substring(slash+1,path.length);
	
	//check for first character. IE issue....
 	if (path.charAt(0)=="/") //IE11
 	   path = path.substring(1,slash+1);
    else    //IE8
       path = path.substring(0,slash+1);

	// replaces all forward slahes with double backward slashes. for some reasons alm accepts double backwards slashes. took me fucking 2 hours to find that ALM issue... :-)
	path = path.replace(/\//g,"\\");
	
	//replaces all "%20" (space) from path variable and replaces it with real "space"
	path = path.replace(/%20/gi, " ");
	//confirm(path + " " + name);
	// get attachment factory
	var attachfact = bug.Attachments;
	// add att item to attachobj
	var attachobj = attachfact.AddItem(name);
	//attach description
	attachobj.Description = "bug attachment";
	//post
	attachobj.Post();
	// add attachment storage
	var extstorage = attachobj.AttachmentStorage;
	//path to local attachment
	extstorage.ClientPath = path;
	//save attachment
	extstorage.Save(name, true);
}

function fallback(parent) {
                // replace <video> with its contents
                var videos = parent.childNodes;
                var link = "";
                for(i=videos.length-1; i >= 0; i--)
                {
                    if (videos[i] instanceof HTMLVideoElement || videos[i] instanceof HTMLAudioElement )
                    {
                        var sources = videos[i].childNodes;
                        for(j=sources.length-1;j>=0;j--)
                        {
                            if (sources[j] instanceof HTMLSourceElement)
                            {
                                link = sources[j].getAttribute("src");
                                break;
                            }
                        }
                        if(link!="")
                        {
                            var aTag = document.createElement('a');
                            aTag.setAttribute('href',link);
                            aTag.innerHTML = link;
                            parent.appendChild(aTag);
                        }
                        parent.removeChild(parent.childNodes[i]);
                    }
                    else
                    {
                        ;
                    }
                }
            }

function sortdropdown(select) {
	$(select).html($(select).children('option').sort(function (x, y) {
	return $(x).text().toUpperCase() < $(y).text().toUpperCase() ? -1 : 1;
	}));
				
	$(select).get(0).selectedIndex = 0;
};